# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import fields
from osv import osv
import netsvc
from tools.translate import _

class StockMove(osv.osv):
    _inherit = 'stock.move'
    _columns = {
        'move_dest_id_lines': fields.one2many('stock.move','move_dest_id', 'Children Moves'),
        'real_operation_id': fields.many2one('mrp.production.operation.real', 'Operation'),
        'real_operation_ids': fields.many2many('mrp.production.operation.real', 'operation_move_prod', 'move_id', 'real_operation_id', 'Products to Consume'),
    }
    
    def copy(self, cr, uid, id, default=None, context=None):
        if default is None:
            default = {}
        default.update({
            'move_dest_id_lines': [],
        })
        return super(StockMove, self).copy(cr, uid, id, default, context)

    def force_assign(self, cr, uid, ids, context=None):
        """ Changes the state to assigned.
        @return: True
        """
        wf_service = netsvc.LocalService("workflow")
        super(StockMove, self).force_assign(cr, uid, ids)
        for move in self.browse(cr, uid, ids):
            for op in move.real_operation_ids:
                wf_service.trg_validate(uid, 'mrp.production.operation.real', op.id, 'check_signal', cr)
        return True
        
StockMove()

class stock_picking(osv.osv):

    _inherit = 'stock.picking' 
 
    _columns = {
            'real_out_op_id': fields.many2many('mrp.production.operation.real', 'mrp_real_op_pick_out_rel', 'pick_id_out', 'real_out_op_id'),
            'real_in_op_id': fields.many2many('mrp.production.operation.real', 'mrp_real_op_pick_in_rel', 'pick_id_in', 'real_in_op_id'),
    }
    
    def action_done(self, cr, uid, ids, context=None):
        """ Changes picking state to done.
        @return: True
        """
        wf_service = netsvc.LocalService("workflow")
        super(stock_picking, self).action_done(cr, uid, ids)
        for pick in self.browse(cr, uid, ids):
            for op in pick.real_out_op_id:
                wf_service.trg_validate(uid, 'mrp.production.operation.real', op.id, 'send_sig', cr)
            for op in pick.real_in_op_id:
                wf_service.trg_validate(uid, 'mrp.production.operation.real', op.id, 'receive_sig', cr)
        return True
stock_picking()