# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import fields, osv
from tools.translate import _
import time

class workflow_wizard(osv.osv_memory):
    _name = "mrp.workflow.wizard"
    _description = "Workflow"
    
    _columns = {
          'real_ope': fields.char('Work Order code', size=64),
     }
    
    def action_start(self, cr, uid, ids, context=None):
        
        real_op_id = context['real_op']        
        real_obj = self.pool.get('mrp.production.operation.real')        
        real_op_search = real_obj.search(cr, uid,[('code','=',real_op_id)] )
        if not real_op_search:
            raise osv.except_osv(_('No Data Available'), _('No records found for your Id'))
        real_op_brow = real_obj.browse(cr, uid, real_op_search)[0]
        
        real_state =   real_op_brow.state

        if real_state == 'ready':
            real_op_brow.action_start_working()
        
        if real_state == 'startworking':
            real_op_brow.action_pause()
        
        if real_state == 'pause':
            real_op_brow.action_resume()
            
        return {'type': 'ir.actions.act_window_close'}
        
workflow_wizard()