# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import osv, fields
from datetime import datetime
from dateutil.relativedelta import relativedelta
from tools.translate import _
import netsvc

class mrp_ops_cost(osv.osv):
    _name = "mrp.ops.cost"
    _inherit = "mrp.ops.cost"
    
    def create(self, cr, uid, data, context=None):
        if context is None:
            context = {}  
        us_obj = self.pool.get('production.opert.users')
        account_analytic_obj = self.pool.get('account.analytic.account')
        input_time_obj = self.pool.get('input.time')
        aux_prod = self.pool.get('mrp.production')
        aux_prod_op = self.pool.get('mrp.production.operation')
  
        new_id = super(mrp_ops_cost, self).create(cr, uid, data, context)     
        ope_cost = self.browse(cr,uid,new_id)
        if ope_cost.create_structure == True:
            us_search = us_obj.search(cr, uid,[('user', '=', ope_cost.user.id),('op','=',ope_cost.operation.id)])
            if len(us_search):
                us = us_search[len(us_search)-1]
            else:
                values = {'user': ope_cost.user.id,
                          'production_id':ope_cost.production.id,
                          'op':ope_cost.operation.id,                
                          }
                us = us_obj.create(cr, uid, values)
                self.write(cr, uid, [ope_cost.id], {'wuser': us})
                
            # Imputación en Contabilidad Analítica
            ope_acc_code = 'OF'+ str(ope_cost.production.name.lstrip('OF/'))+'-OP'+str(ope_cost.operation.sequence)
            account_search = account_analytic_obj.search(cr, uid, [('code','=',ope_acc_code)])
            if not account_search:
                raise osv.except_osv(_('ERROR'), _('Analytic Account with code: %s NOT FOUND') %(ope_acc_code))
            
            ope_account_id=False
            
            for aux_var in account_search:
                ope_account_id = aux_var
                
            if ope_account_id:
                resu = input_time_obj.analityc_inpute(cr, uid ,ope_cost.date,ope_cost.descript,ope_cost.user.id,ope_cost.time, ope_cost.operation.id, ope_cost.production.id)
        
            #Times
            op = aux_prod_op.browse(cr , uid, ope_cost.operation.id)
            op_time_add = op.tot_ops + ope_cost.time
            tot_time_add = op.tot + ope_cost.time
            aux_prod_op.write(cr, uid, [op.id], {'tot_ops':op_time_add , 'tot':tot_time_add  })  

        return new_id
    
    def unlink(self, cr, uid, ids, context=None):
        if context is None:
            context = {}  
            
        production_obj = self.pool.get('mrp.production')
        operation_obj = self.pool.get('mrp.production.operation')
        analytic_account_obj = self.pool.get('account.analytic.account')
        analytic_account_line_obj = self.pool.get('account.analytic.line')
        usr_object = self.pool.get('res.users')
        usr_obj = self.pool.get('hr.employee')
        product_obj = self.pool.get('product.product')
        res_company_obj = self.pool.get('res.company')
        account_analytic_jour_obj = self.pool.get('account.analytic.journal')
            
        if ids:
            for ope_cost in self.browse(cr,uid,ids):
                # Descuento Tiempos de producción
                if ope_cost.production:
                    production = production_obj.browse(cr, uid, ope_cost.production.id)
                    values = {'tot': production.tot - ope_cost.time,
                              'tot_ops': production.tot_mac - ope_cost.time
                              }
                    production_obj.write(cr, uid, [production.id], values)  
                # Descuento Tiempos de la operación
                if ope_cost.operation:
                    operation = operation_obj.browse(cr , uid, ope_cost.operation.id)
                    op_time_add = operation.tot_ops - ope_cost.time
                    tot_time_add = operation.tot - ope_cost.time
                    operation_obj.write(cr, uid, [operation.id], {'tot_ops':op_time_add , 'tot':tot_time_add  })  
                # Borro la cuenta analítica
                parent_code = 'OF' + str(ope_cost.production.name.lstrip('OF/')) + '-OP' + str(ope_cost.operation.sequence) 
                parent_account = analytic_account_obj.search(cr, uid, [('code','=',parent_code)])[0]
                if not parent_account:
                    raise osv.except_osv(_('ERROR'), _('Analytic Account with code: %s NOT FOUND') %(parent_code))
                prod_wrk_name_acc_code = parent_code + '-WK'+ str(ope_cost.user.id)   
                usr = usr_object.browse(cr,uid,ope_cost.user.id)
                nombre  = usr.name                      
                account_ids = analytic_account_obj.search(cr, uid, [('name','=',prod_wrk_name_acc_code + " " + ' Operario '+ str(nombre)),
                                                                    ('code','=',prod_wrk_name_acc_code),
                                                                    ('currency_id','=',1),
                                                                    ('company_id','=',1),
                                                                    ('state','=','open'),
                                                                    ('parent_id','=',parent_account),
                                                                    ('acc_type','=','OP')])
                analytic_account_obj.unlink(cr,uid,account_ids)
                # Borro el apunte analítico
                usr_search = usr_obj.search(cr, uid,[('user_id', '=', ope_cost.user.id)])
                if not usr_search:
                    user = usr_object.browse(cr,uid, ope_cost.user.id)
                    raise osv.except_osv(_('The user IS NOT employ'), _(user.name)) 
                usr = usr_obj.browse(cr , uid, usr_search[0])
                aux_product = product_obj.browse(cr , uid, usr.product_id.id) 
                op_cost_amount = aux_product.standard_price * ope_cost.time
                
                company_ids = res_company_obj.search(cr, uid,[])
                operator_account = 0
                if company_ids:
                    for company in res_company_obj.browse(cr,uid,company_ids):
                        operator_account = company.operator_account.id
                
                man_journal_search = account_analytic_jour_obj.search(cr, uid,[('name', '=', 'Manufacturing')])        
                man_journal = account_analytic_jour_obj.browse(cr, uid, man_journal_search[0]) 
                
                ope_acc_code = 'OF' + str(ope_cost.production.name.lstrip('OF/')) + '-OP' + str(ope_cost.operation.sequence) + '-WK'+ str(ope_cost.user.id)
                ope_account_id = False
                account_search = analytic_account_obj.search(cr, uid, [('code','=',ope_acc_code)])
                for aux_var in account_search:
                    ope_account_id = aux_var
 
                analytic_line_ids = analytic_account_line_obj.search(cr, uid, [('amount','=',op_cost_amount*(-1)),
                                                                               ('name','=',str(usr.name) + ' worker imputation'),
                                                                               ('date','=',ope_cost.date),
                                                                               ('company_id','=',1),
                                                                               ('general_account_id','=',operator_account),
                                                                               ('account_id','=',ope_account_id),
                                                                               ('journal_id','=',man_journal.id),
                                                                               ('ref','=',ope_cost.production.name),
                                                                               ('unit_amount','=',1),
                                                                               ('product_id','=',usr.product_id.id)])
                analytic_account_line_obj.unlink(cr,uid,analytic_line_ids)

        super(mrp_ops_cost,self).unlink(cr, uid, ids, context=context)

        return True
    
    def write(self, cr, uid, ids, vals, context=None):
        if context is None:
            context = {}
            
        production_obj = self.pool.get('mrp.production')
        operation_obj = self.pool.get('mrp.production.operation')
        analytic_account_obj = self.pool.get('account.analytic.account')
        analytic_account_line_obj = self.pool.get('account.analytic.line')
        usr_object = self.pool.get('res.users')
        usr_obj = self.pool.get('hr.employee')
        product_obj = self.pool.get('product.product')
        res_company_obj = self.pool.get('res.company')
        account_analytic_jour_obj = self.pool.get('account.analytic.journal')
            
        if ids:
            for ope_cost in self.browse(cr,uid,ids):
                if vals.has_key('time'):
                    new_time = vals.get('time')
                    if new_time == ope_cost.time:
                        super(mrp_ops_cost, self).write(cr, uid, [ope_cost.id], vals, context=context)
                    else:
                        # Descuento Tiempos de producción
                        if ope_cost.production:
                            production = production_obj.browse(cr, uid, ope_cost.production.id)
                            values = {'tot': production.tot - ope_cost.time,
                                      'tot_ops': production.tot_mac - ope_cost.time
                                      }
                            production_obj.write(cr, uid, [production.id], values)  
                        # Descuento Tiempos de la operación
                        if ope_cost.operation:
                            operation = operation_obj.browse(cr , uid, ope_cost.operation.id)
                            op_time_add = operation.tot_ops - ope_cost.time
                            tot_time_add = operation.tot - ope_cost.time
                            operation_obj.write(cr, uid, [operation.id], {'tot_ops':op_time_add , 'tot':tot_time_add  }) 
                        # Busco el Apunte Analítico con el importe viejo
                        usr_search = usr_obj.search(cr, uid,[('user_id', '=', ope_cost.user.id)])
                        if not usr_search:
                            user = usr_object.browse(cr,uid, ope_cost.user.id)
                            raise osv.except_osv(_('The user IS NOT employ'), _(user.name)) 
                        usr = usr_obj.browse(cr , uid, usr_search[0])
                        aux_product = product_obj.browse(cr , uid, usr.product_id.id) 
                        op_cost_amount = aux_product.standard_price * ope_cost.time
                        
                        company_ids = res_company_obj.search(cr, uid,[])
                        operator_account = 0
                        if company_ids:
                            for company in res_company_obj.browse(cr,uid,company_ids):
                                operator_account = company.operator_account.id
                        
                        man_journal_search = account_analytic_jour_obj.search(cr, uid,[('name', '=', 'Manufacturing')])        
                        man_journal = account_analytic_jour_obj.browse(cr, uid, man_journal_search[0])        
                        
                        ope_acc_code = 'OF' + str(ope_cost.production.name.lstrip('OF/')) + '-OP' + str(ope_cost.operation.sequence) + '-WK'+ str(ope_cost.user.id)
                        ope_account_id = False
                        account_search = analytic_account_obj.search(cr, uid, [('code','=',ope_acc_code)])
                        for aux_var in account_search:
                            ope_account_id = aux_var       
                        
                        analytic_line_ids = analytic_account_line_obj.search(cr, uid, [('amount','=',op_cost_amount*(-1)),
                                                                                       ('name','=',str(usr.name) + ' worker imputation'),
                                                                                       ('date','=',ope_cost.date),
                                                                                       ('company_id','=',1),
                                                                                       ('general_account_id','=',operator_account),
                                                                                       ('account_id','=',ope_account_id),
                                                                                       ('journal_id','=',man_journal.id),
                                                                                       ('ref','=',ope_cost.production.name),
                                                                                       ('unit_amount','=',1),
                                                                                       ('product_id','=',usr.product_id.id)])

                        # Llamo al metodo super
                        super(mrp_ops_cost, self).write(cr, uid, [ope_cost.id], vals, context=context)
                        ope_cost2 = self.browse(cr,uid,ope_cost.id)
                        
                        # Imputo Tiempos de producción
                        if ope_cost2.production:
                            production = production_obj.browse(cr, uid, ope_cost2.production.id)
                            values = {'tot': production.tot + ope_cost2.time,
                                      'tot_ops': production.tot_mac + ope_cost2.time
                                      }
                            production_obj.write(cr, uid, [production.id], values)  
                        # Imputo Tiempos de la operación
                        if ope_cost2.operation:
                            operation = operation_obj.browse(cr , uid, ope_cost2.operation.id)
                            op_time_add = operation.tot_ops + ope_cost2.time
                            tot_time_add = operation.tot + ope_cost2.time
                            operation_obj.write(cr, uid, [operation.id], {'tot_ops':op_time_add , 'tot':tot_time_add  }) 
                        # Modifico el Importe Analítico con el Importe Nuevo  
                        op_cost_amount = aux_product.standard_price * ope_cost2.time
                        analytic_account_line_obj.write(cr, uid, [analytic_line_ids[0]], {'amount': op_cost_amount*(-1)}) 
                        analytic_account_obj.recalculate_result(cr, uid, ope_account_id)
        
        return True
    
mrp_ops_cost()