# -*- encoding: utf-8 -*-
##############################################################################
#
#    Avanzosc - Avanced Open Source Consulting
#    Copyright (C) 2010 - 2011 Avanzosc <http://www.avanzosc.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import fields, osv

class mrp_analytic_installer(osv.osv_memory):
    _name = 'mrp.analytic.installer'
    _inherit = 'res.config'

    _columns = {
        'material_account': fields.many2one('account.account', 'Material Cost Account', domain="[('type', '=', 'other')]", help="Account to impute material costs"),
        'workcenter_account': fields.many2one('account.account', 'Workcenter Cost Account', domain="[('type', '=', 'other')]", help="Account to impute workcenter costs"),
        'operator_account': fields.many2one('account.account', 'Operator Cost Account', domain="[('type', '=', 'other')]", help="Account to impute operator costs"),
    }

    def execute(self, cr, uid, ids, context=None):
        data = self.read(cr, uid, ids, context=context)
        company_obj = self.pool.get('res.company')
        default_co = company_obj._company_default_get(cr, uid, 'mrp.routing', context=context)
        if not data:
            return {}
        mt_acc = data[0]['material_account']
        wk_acc = data[0]['workcenter_account']
        op_acc = data[0]['operator_account']
        
        values = {
            'material_account': mt_acc,
            'workcenter_account': wk_acc,
            'operator_account': op_acc,
        }
#        data_pool = self.pool.get('ir.model.data')
#        transition_obj = self.pool.get('workflow.transition')
#        waiting = data_pool._get_id(cr, uid, 'purchase_triple_validation', 'trans_validated_router')
#        waiting_id = data_pool.browse(cr, uid, waiting, context=context).res_id
#        confirm = data_pool._get_id(cr, uid, 'purchase_triple_validation', 'trans_waiting_validated_router')
#        confirm_id = data_pool.browse(cr, uid, confirm, context=context).res_id
        company_obj.write(cr, uid, default_co, values)
        return {}

mrp_analytic_installer()