# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

import time
from datetime import datetime

from osv import osv, fields
import tools
from tools.translate import _

class manufacturing_user(osv.osv_memory):
    
    _name = "manufacturing.user"
    _inherit = "manufacturing.user"
    
    
    def add_user(self, cr, uid, ids, context=None):
        
        if context is None:
            context = {}
        
        objs = self.pool.get('mrp.production').browse(cr , uid, context['active_ids'])
        objs2 = self.pool.get('mrp.production.users')
        
        con_user = []
        con_ops = []
        for obj in objs:
          for usr_op in obj.user_ops:
              con_user.append((usr_op.name.id, usr_op.op.id)) 
          obj_ops = self.pool.get('mrp.production.operation')
          ops_ids = obj_ops.search(cr, uid,[('production_id', '=',obj.id )])
          con_ops = obj_ops.browse(cr , uid, ops_ids)
             
         
        usr = context['user'] 
        percent = context['percent']
        
        if not usr:
            raise osv.except_osv(_('Unable to perform action'), _('You must select Operator'))    
          
       
        for check in con_ops:
            create = True
            for check_op in con_user:
                if check_op == (usr, check.id):
                    create = False
            if create:
                est_time =  check.hour * percent /100   
                values = {
                        'name': usr,
                        'op':check.id,
                        'prod':context['active_ids'][0],
                        'percent': percent,
                        'est_time':est_time,
                        }   
                
                
                res = objs2.create(cr, uid, values)                 
        
              
        
    
#Crear cuenta analitica de operadores por estimación
                     
                account_analytic_obj = self.pool.get('account.analytic.account')
                account_analytic_jour_obj = self.pool.get('account.analytic.journal')          
                mrp_production = self.pool.get('mrp.production').browse(cr,uid,context['active_ids'][0])             
                prod_acc_code = 'OF'+ str(mrp_production.name.lstrip('OF/')) + '-OP' + str(check.sequence)      
                prod_op_acc = account_analytic_obj.search(cr, uid, [('code','=', prod_acc_code)])
                if not prod_op_acc:
                    raise osv.except_osv(_('ERROR'), _('Analytic Account with code: %s NOT FOUND') %(prod_acc_code))
                else:    
 					# TODO: Change this to use code instead for translational option
                    # man_journal_search = account_analytic_jour_obj.search(cr, uid,[('code', '=', 'MRP')])
                    man_journal_search = account_analytic_jour_obj.search(cr, uid,[('name', '=', 'Manufacturing')])      
                    man_jounal = account_analytic_jour_obj.browse(cr, uid, man_journal_search[0])                            
                       
                    user_search = self.pool.get('hr.employee').search(cr, uid, [('user_id','=',usr)])
                    if not user_search:
                        raise osv.except_osv(_('You must assign a product to all employers'), _(usr))  
                        
                    user_employer = self.pool.get('hr.employee').browse(cr, uid, user_search[0])
                    user_product = self.pool.get('product.product').browse(cr, uid, user_employer.product_id.id)
                    
                    total_estimated=0
                    
                    oper = self.pool.get('mrp.production.operation').browse(cr,uid,check.id)
                    total_estimated = total_estimated + ((percent / 100) * user_product.standard_price * oper.hour)

                    prod_wrk_name_acc_code = prod_acc_code + '-WK'+ str(usr) 
                    
                    prod_wrk_acc = account_analytic_obj.search(cr, uid, [('code','=', prod_wrk_name_acc_code)])
                    
                    #compruebo que existe y adjudico el estimado o no existe y lo creo
                    
                    if prod_wrk_acc:
                        account_analytic_obj.write(cr, uid,prod_wrk_acc[0],{'total_estimated':total_estimated})
                        account_analytic_obj.recalculate_result(cr, uid, prod_wrk_acc[0])
                    else:
                        user = self.pool.get('res.users').browse(cr,uid,usr)
                        nombre  = user.name         
                        values={
                            'name':prod_wrk_name_acc_code + " " + 'Operario '+ str(nombre),
                            'code':prod_wrk_name_acc_code ,
                            'currency_id':1,
                            'company_id':1,
                            'state':'open',
                            'parent_id':prod_op_acc[0],
                            'total_estimated':total_estimated,
                            }
                        
                        
                        man_wrk_account = account_analytic_obj.create(cr, uid, values)
                        account_analytic_obj.calculate_estimated(cr, uid, prod_op_acc[0], total_estimated, 0, 0)                                
                        account_analytic_obj.recalculate_result(cr, uid, man_wrk_account)

        return {'type': 'ir.actions.act_window_close'}
manufacturing_user()

class input_time(osv.osv_memory):
    _inherit = "input.time"
    _name = "input.time"
    _description = "Input time"
    
    
    def create_new_analityc_operator_account(self, cr, uid, user_in, op_in, prod_in, context=None):
        #Crear cuenta analitica de operadores                
        account_analityc_obj = self.pool.get('account.analytic.account') 
        mrp_production_obj = self.pool.get('mrp.production')
        mrp_production_operation_obj = self.pool.get('mrp.production.operation')             
                                                                         
        usr_object = self.pool.get('res.users')
        usr = usr_object.browse(cr,uid,user_in)
        nombre  = usr.name      
        mrp_production = mrp_production_obj.browse(cr,uid,prod_in)
        mrp_production_operation = mrp_production_operation_obj.browse(cr,uid,op_in)
        
        parent_code = 'OF' + str(mrp_production.name.lstrip('OF/')) + '-OP' + str(mrp_production_operation.sequence) 
        parent_account = account_analityc_obj.search(cr, uid, [('code','=',parent_code)])[0]
        if not parent_account:
            raise osv.except_osv(_('ERROR'), _('Analytic Account with code: %s NOT FOUND') %(parent_code))
   
        prod_wrk_name_acc_code = parent_code + '-WK'+ str(user_in) 
                        
        values={
        'name':prod_wrk_name_acc_code + " " + ' Operario '+ str(nombre),
        'code':prod_wrk_name_acc_code ,
        'currency_id':1,
        'company_id':1,
        'state':'open',
        'parent_id':parent_account,
        'acc_type':'OP'
            }
                        
                        
                        
        man_wrk_account = account_analityc_obj.create(cr, uid, values)
                  
        return man_wrk_account
    
    
    
    def analityc_inpute(self, cr, uid,  in_date, in_description, in_user, in_time, in_op, in_prod, context=None):
        #calculo de ammount
        res_company_obj = self.pool.get('res.company')
        mrp_production_obj = self.pool.get('mrp.production')
        mrp_production_operation_obj = self.pool.get('mrp.production.operation')     
        company_ids = res_company_obj.search(cr, uid,[])
        user_obj = self.pool.get('res.users')
        usr_obj = self.pool.get('hr.employee')
        operator_account = 0
        if company_ids:
            for company in res_company_obj.browse(cr,uid,company_ids):
                operator_account = company.operator_account.id
                
        mrp_production = mrp_production_obj.browse(cr,uid,in_prod)
        mrp_production_operation = mrp_production_operation_obj.browse(cr,uid,in_op)
                
        usr_search = usr_obj.search(cr, uid,[('user_id', '=', in_user)])
        if not usr_search:
            user = user_obj.browse(cr,uid, in_user)
            raise osv.except_osv(_('The user IS NOT employ'), _(user.name)) 
        usr = usr_obj.browse(cr , uid, usr_search[0])
        if not usr.product_id:
            raise osv.except_osv(_('You must assign a product to all employers'), _(usr.name))                
        aux_product = self.pool.get('product.product').browse(cr , uid, usr.product_id.id) 
        
        op_cost_amount = aux_product.standard_price * in_time
        
        #busqueda y asignación de cuenta analitica correspondiente
        
        ope_acc_code = 'OF' + str(mrp_production.name.lstrip('OF/')) + '-OP' + str(mrp_production_operation.sequence) + 'WK'+ str(in_user)
        
        ope_account_id = False
        
        account_analytic_obj = self.pool.get('account.analytic.account')
        account_analytic_jour_obj = self.pool.get('account.analytic.journal')
        account_analytic_line_obj = self.pool.get('account.analytic.line')
    
        account_search = account_analytic_obj.search(cr, uid, [('code','=',ope_acc_code)])
        for aux_var in account_search:
            ope_account_id = aux_var
        
        if not ope_account_id:
            ope_account_id=self.create_new_analityc_operator_account(cr, uid, in_user, in_op, in_prod)                            
        
        
        man_journal_search = account_analytic_jour_obj.search(cr, uid,[('name', '=', 'Manufacturing')])        
        man_journal = account_analytic_jour_obj.browse(cr, uid, man_journal_search[0])
        
        production = self.pool.get('mrp.production').browse(cr,uid,in_prod)
        values = {'amount': op_cost_amount*(-1),
                  'name': str(usr.name) + ' worker imputation',
                  'date': in_date,
                  'company_id':1,
                  'account_id': ope_account_id,
                  'general_account_id': operator_account,
                  'journal_id':man_journal.id,
                  'ref': production.name,
                  'unit_amount': 1,
                  'product_id': usr.product_id.id
                  }            
        new_id = account_analytic_line_obj.create(cr, uid, values)          
        account_analytic_obj.recalculate_result(cr, uid, ope_account_id)
        
        return True
    
    def input_worktime(self, cr, uid, fields, context=None):
        
        if context is None:
            context = {}
        
        if not context['descript']:
            raise osv.except_osv(_('Missing data'), _('A job description should be given'))
        
        if context['wtime']<=0:
            raise osv.except_osv(_('The time must be greater than 0'), _(context['wtime']))
        
        aux_prod = self.pool.get('mrp.production')
        aux_prod_op = self.pool.get('mrp.production.operation')
        op = aux_prod_op.browse(cr , uid, context['operation'])
        
        prod = aux_prod.browse(cr , uid, op.production_id.id)
        
        ops_us_obj = self.pool.get('mrp.ops.cost')
        
        us_obj = self.pool.get('production.opert.users')
        us_search = us_obj.search(cr, uid,[('user', '=', context['wuser'] ),('op','=',op.id)])
        if len(us_search):
            us = us_search[len(us_search)-1]
        else:
            values = {
                'user' :context['wuser'],
                'production_id':op.production_id.id,
                'op':op.id,                
                   }
            res = us_obj.create(cr, uid, values)
            us_search = us_obj.search(cr, uid,[('user', '=', context['wuser'] ),('op','=',op.id)])
            us = us_search[0]
        
        real_op_obj = self.pool.get('mrp.production.operation.real')
        real_op_search = real_op_obj.search(cr, uid,[('mrp_manu_op', '=', op.id )])  
        if not real_op_search:
            raise osv.except_osv(_('Unable to perform action'), _('Could not find the real operation: %s') %(op.name))      
        real_id = real_op_obj.browse(cr, uid, real_op_search[0])
        
        if real_id.state == 'draft':
            raise osv.except_osv(_('Unable to perform action'), _('Operation must be started to allocate hours')) 
        
        values = {
          'wuser': us,
          'user': context['wuser'],
          'operation': op.id,
          'time': context['wtime'],
          'date': context['work_date'],
          'descript': context['descript'],
          'production': prod.id,
          'real_op' : real_id.id
            }
        
        res = ops_us_obj.create(cr, uid, values)
        
        
        # inputación a contabilidad analitica
        ope_acc_code = 'OF'+ str(prod.name.lstrip('OF/'))+'-OP'+str(op.sequence)
        account_analytic_obj = self.pool.get('account.analytic.account')
        account_search = account_analytic_obj.search(cr, uid, [('code','=',ope_acc_code)])
        if not account_search:
            raise osv.except_osv(_('ERROR'), _('Analytic Account with code: %s NOT FOUND') %(ope_acc_code))
        
        ope_account_id=False
        
        for aux_var in account_search:
            ope_account_id = aux_var
            
        if ope_account_id:
            resu = self.analityc_inpute(cr, uid ,context['work_date'],context['descript'],context['wuser'],context['wtime'],op.id, prod.id)
        
        
        #Times
        op_time_add = op.tot_ops + context['wtime']
        tot_time_add = op.tot + context['wtime']
        aux_prod_op.write(cr, uid, context['operation'], {'tot_ops':op_time_add , 'tot':tot_time_add  })
        
        prod_op_time_add = prod.tot_ops + context['wtime']
        prod_tot_time_add = prod.tot + context['wtime']
        aux_prod.write(cr, uid, prod.id, {'tot_ops':prod_op_time_add , 'tot':prod_tot_time_add  })
        
        return {'type': 'ir.actions.act_window_close'}
    
input_time()

class new_input_time(osv.osv_memory):
    _inherit = "new.input.time"
    _name = "new.input.time"
    _description = "new_Input time"
    

    
    def input_worktime(self, cr, uid, fields, context=None):
        if context is None:
            context = {}
        
        if context['wtime']<=0:
            raise osv.except_osv(_('The time must be greater than 0'), _(context['wtime']))
        
        if not context['descript']:
            raise osv.except_osv(_('Missing data'), _('A job description should be given'))
        
        aux_prod = self.pool.get('mrp.production')
        aux_prod_op = self.pool.get('mrp.production.operation')
        op = aux_prod_op.browse(cr , uid, context['operation'])
        
        
        
        prod = aux_prod.browse(cr , uid, op.production_id.id)
        
        ops_us_obj = self.pool.get('mrp.ops.cost')
        
        us_obj = self.pool.get('production.opert.users')
        us_search = us_obj.search(cr, uid,[('user', '=', context['wuser'] ),('op','=',op.id)])
        if len(us_search):
            us = us_search[len(us_search)-1]
        else:
            values = {
                'user' :context['wuser'],
                'production_id':op.production_id.id,
                'op':op.id,                
                   }
            res = us_obj.create(cr, uid, values)
            us_search = us_obj.search(cr, uid,[('user', '=', context['wuser'] ),('op','=',op.id)])
            us = us_search[0]
            
        
        
        
        real_op_obj = self.pool.get('mrp.production.operation.real')
        real_op_search = real_op_obj.search(cr, uid,[('mrp_manu_op', '=', op.id )])        
        real_id = real_op_obj.browse(cr, uid, real_op_search[0])
        
        if real_id.state == 'draft':
            raise osv.except_osv(_('Unable to perform action'), _('Operation must be started to allocate hours')) 
        
        values = {
          'wuser': us,
          'user': context['wuser'],
          'operation': op.id,
          'time': context['wtime'],
          'date': context['work_date'],
          'descript': context['descript'],
          'production': prod.id,
          'real_op': real_id.id
            }
        
        res = ops_us_obj.create(cr, uid, values)
        
        
        #INPUTACIÖN ANALITICA
        
        input_obj = self.pool.get("input.time")
        
        ope_acc_code = 'OF'+ str(prod.name.lstrip('OF/'))+'-OP'+str(op.sequence)
        account_analytic_obj = self.pool.get('account.analytic.account')
        account_search = account_analytic_obj.search(cr, uid, [('code','=',ope_acc_code)])
        if not account_search:
            raise osv.except_osv(_('ERROR'), _('Analytic Account with code: %s NOT FOUND') %(ope_acc_code))    
        
        ope_account_id=False
        
        for aux_var in account_search:
            ope_account_id = aux_var
            
        if ope_account_id:
            resu = input_obj.analityc_inpute(cr, uid ,context['work_date'],context['descript'],context['wuser'],context['wtime'],op.id, prod.id)       
        
        
        op_time_add = op.tot_ops + context['wtime']
        tot_time_add = op.tot + context['wtime']
        aux_prod_op.write(cr, uid, context['operation'], {'tot_ops':op_time_add , 'tot':tot_time_add  })
        
        
        return {'type': 'ir.actions.act_window_close'}
    
    
    def input_real_worktime(self, cr, uid, ids, in_wuser, in_wtime, in_op, in_date, in_desc,  context=None):
        if context is None:
            context = {}
        
        if in_wtime<=0:
            raise osv.except_osv(_('The time must be greater than 0'), _(in_wtime))
        
        aux_prod = self.pool.get('mrp.production')
        aux_prod_op = self.pool.get('mrp.production.operation')
        op = aux_prod_op.browse(cr , uid, in_op)                
        
        prod = aux_prod.browse(cr , uid, op.production_id.id)
            
        ops_us_obj = self.pool.get('mrp.ops.cost')
        
        us_obj = self.pool.get('production.opert.users')
        us_search = us_obj.search(cr, uid,[('user', '=', in_wuser ),('op','=',op.id)])
        if len(us_search):
            us = us_search[len(us_search)-1]
        else:
            values = {
                'user': in_wuser,
                'production_id': op.production_id.id,
                'op': op.id,                
                   }
            res = us_obj.create(cr, uid, values)
            us_search = us_obj.search(cr, uid,[('user', '=', in_wuser ),('op','=',op.id)])
            us = us_search[0]
            
                        
        real_op_obj = self.pool.get('mrp.production.operation.real')
        real_op_search = real_op_obj.search(cr, uid,[('mrp_manu_op', '=', op.id )])        
        real_id = real_op_obj.browse(cr, uid, real_op_search[0])
        
        if real_id.state == 'draft':
            raise osv.except_osv(_('Unable to perform action'), _('Operation must be started to allocate hours')) 
        
        values = {
          'wuser': us,
          'user': in_wuser,
          'operation': op.id,
          'time': in_wtime,
          'date': in_date,
          'descript': in_desc,
          'production': prod.id,
          'real_op': real_id.id
            }
        
        res = ops_us_obj.create(cr, uid, values)
        
        
        #INPUTACIÖN ANALITICA
        
        input_obj = self.pool.get("input.time")
        
        ope_acc_code = 'OF'+ str(prod.name.lstrip('OF/'))+'-OP'+str(op.sequence)
        account_analytic_obj = self.pool.get('account.analytic.account')
        account_search = account_analytic_obj.search(cr, uid, [('code','=',ope_acc_code)])
        if not account_search:
            raise osv.except_osv(_('ERROR'), _('Analytic Account with code: %s NOT FOUND') %(ope_acc_code))
        
        ope_account_id=False
        
        for aux_var in account_search:
            ope_account_id = aux_var
            
        if ope_account_id:
            resu = input_obj.analityc_inpute(cr, uid ,in_date,in_desc,in_wuser,in_wtime,op.id, prod.id)       
        
        
        op_time_add = op.tot_ops + in_wtime
        tot_time_add = op.tot + in_wtime
        aux_prod_op.write(cr, uid, op.id, {'tot_ops':op_time_add , 'tot':tot_time_add  })
        
        return True
    
new_input_time()


class manufacturing_user_op_add(osv.osv_memory):
    _inherit = "manufacturing.user.op.add"
    _name = "manufacturing.user.op.add"
    _description = "Manufacturing new user"
    
    

    
    def add_user_op(self, cr, uid, ids, context=None):
        
        if context is None:
            context = {}
        
        production = context['production']
        mrp_production_operation_obj = self.pool.get('mrp.production.operation')
        
        objs = self.pool.get('mrp.production').browse(cr , uid, production)   

        usr = context['user']
        percent = context['percent']
        
        objs2    = self.pool.get('mrp.production.users')
        objs2_id = objs2.search(cr, uid,[('prod', '=', [production])])
        objs2_s  = objs2.browse(cr , uid, objs2_id)
        
        con_user = []
        
        for usr_op in objs2_s:
              con_user.append((usr_op.name.id, usr_op.op.id)) 

        check = context['operation']
        st_est_time = context['est_time']
        
        est_time_list = st_est_time.rsplit(':')
        est_time = float(est_time_list[0])+(float(est_time_list[1])/60)+(float(est_time_list[2])/360)

        create = True
        
        for check_op in con_user:
            if check_op == (usr, check):
                    create = False
        if create:
             values = {
                            'name': usr,
                            'op':check,
                            'prod':production,
                            'percent':percent,
                            'est_time':est_time
                            }   
             res = objs2.create(cr, uid, values)

            #Crear cuenta analitica de operadores por estimación
             
             account_analytic_obj = self.pool.get('account.analytic.account')
             account_analytic_jour_obj = self.pool.get('account.analytic.journal')
             mrp_production_operation = mrp_production_operation_obj.browse(cr,uid, check)
             
             prod_acc_code = 'OF'+ str(objs2_s.name.lstrip('OF/')) + '-OP' + str( mrp_production_operation.sequence)
             prod_op_acc = account_analytic_obj.search(cr, uid, [('code','=', prod_acc_code)])
             if not prod_op_acc:
                 raise osv.except_osv(_('ERROR'), _('Analytic Account with code: %s NOT FOUND') %(prod_acc_code))
             else:
                man_journal_search = account_analytic_jour_obj.search(cr, uid,[('name', '=', 'Manufacturing')])      
                man_jounal = account_analytic_jour_obj.browse(cr, uid, man_journal_search[0])                            
                   
                user_search = self.pool.get('hr.employee').search(cr, uid, [('user_id','=',usr)])
                if not user_search:
                    raise osv.except_osv(_('You must assign a product to all employers'), _(usr))  
                    
                user_employer = self.pool.get('hr.employee').browse(cr, uid, user_search[0])
                user_product = self.pool.get('product.product').browse(cr, uid, user_employer.product_id.id)

                total_estimated=0
                
                oper = self.pool.get('mrp.production.operation').browse(cr,uid,check)
                total_estimated = total_estimated + ((percent / 100) * user_product.standard_price * oper.hour)

                prod_wrk_name_acc_code = prod_acc_code + '-WK'+ str(usr) 
                
                prod_wrk_acc = account_analytic_obj.search(cr, uid, [('code','=', prod_wrk_name_acc_code)])
                
                #compruebo que existe y adjudico el estimado o no existe y lo creo
                
                if prod_wrk_acc:
                    account_analytic_obj.write(cr, uid,prod_wrk_acc[0],{'total_estimated':total_estimated})
                    account_analytic_obj.recalculate_result(cr, uid, prod_wrk_acc[0])
                else:
                    
                    user = self.pool.get('res.users').browse(cr,uid,usr)
                    nombre  = user.name         
                    values={
                        'name':prod_wrk_name_acc_code + " " + ' Operario '+ str(nombre),
                        'code':prod_wrk_name_acc_code ,
                        'currency_id':1,
                        'company_id':1,
                        'state':'open',
                        'parent_id':prod_op_acc[0],
                        'total_estimated':total_estimated,
                        }
                    
                    
                    man_wrk_account = account_analytic_obj.create(cr, uid, values)
                    account_analytic_obj.calculate_estimated(cr, uid, prod_op_acc[0], total_estimated, 0, 0)                                
                    account_analytic_obj.recalculate_result(cr, uid, man_wrk_account)
                                     
        
              
        return {'type': 'ir.actions.act_window_close'}
    
manufacturing_user_op_add()

class mrp_production_users(osv.osv):
    _inherit = 'mrp.production.users'    
    _name = 'mrp.production.users'    
    
    def delete_it(self, cr, uid, ids, context=None):        
        user = self.browse(cr, uid, ids)[0]
        account_analytic_obj = self.pool.get('account.analytic.account')
        acc_code = 'OF'+str(user.prod.name.lstrip('OF/'))+'-OP'+str(user.op.sequence)+'-WK'+ str(user.name.id)
        acc_id = account_analytic_obj.search(cr, uid,[('code','=',acc_code)])
        if not acc_id:
            raise osv.except_osv(_('ERROR'), _('Analytic Account with code: %s NOT FOUND') %(acc_code))
        account_analytic_obj.write(cr, uid,acc_id,{'total_estimated':0,
                                                   'total_estimated_puc':0,
                                                   'total_estimated_standard':0} )
        self.unlink(cr, uid,ids, context=context)
        return False
mrp_production_users()
