# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

import time
from datetime import datetime

from osv import osv, fields
import tools
from tools.translate import _




class input_time_wc(osv.osv_memory):
    
    _inherit = "input.time.wc"
    _name = "input.time.wc"
    _description = "Input time"   
       
    def create_new_analityc_operator_account(self, cr, uid, user_in, op_in, prod_in, context=None):
        
        #Crear cuenta analitica de operadores
                        
        account_analityc_obj = self.pool.get('account.analytic.account')  
        mrp_production_obj = self.pool.get('mrp.production')           
        mrp_production_operation_obj = self.pool.get('mrp.production.operation') 
                                                                         
        usr_object = self.pool.get('res.users')
        usr = usr_object.browse(cr,uid,user_in)
        nombre  = usr.name  
        
        mrp_production = mrp_production_obj.browse(cr,uid,prod_id)   
        mrp_production_operation = mrp_production_operation_obj.browse(cr,uid,op_in) 
        
        parent_code = 'OF'+ str(mrp_production.name.lstrip('OF/')) + '-OP' + str(mrp_production_operation.sequence)
        parent_account = account_analityc_obj.search(cr, uid, [('code','=',parent_code)])[0]
        if not parent_account:
            raise osv.except_osv(_('ERROR'), _('Analytic Account with code: %s NOT FOUND') %(parent_code))

        prod_wrk_name_acc_code = parent_code + '-WK'+ str(user_in) 
                        
        values={
        'name':prod_wrk_name_acc_code + " " + ' Operario '+ str(nombre),
        'code':prod_wrk_name_acc_code ,
        'currency_id':1,
        'company_id':1,
        'state':'open',
        'parent_id':parent_account,
        'acc_type':'MA'
            }
                               
        man_wrk_account = account_analityc_obj.create(cr, uid, values)
                  
        return man_wrk_account

    
    def analityc_inpute(self, cr, uid,  in_date, in_description, in_wc, in_time, in_op, in_prod, context=None):

        #calculo de ammount
        
        wc_obj = self.pool.get('mrp.workcenter')
        usr_search = wc_obj.search(cr, uid,[('id', '=', in_wc)])
        wc = wc_obj.browse(cr , uid, usr_search[0])
        if not wc.product_id:
            raise osv.except_osv(_('You must assign a product to all employers'), _(wc.name))                
        aux_product = self.pool.get('product.product').browse(cr , uid, wc.product_id.id) 
        
        op_cost_amount = aux_product.standard_price * in_time
        
        mrp_production_obj = self.pool.get('mrp.production')           
        mrp_production_operation_obj = self.pool.get('mrp.production.operation') 
        
        #busqueda y asignación de cuenta analitica correspondiente
        mrp_production = mrp_production_obj.browse(cr,uid,in_prod)
        mrp_production_operation = mrp_production_operation_obj.browse(cr,uid,in_op)
        
        ope_acc_code = 'OF'+ str(mrp_production.name.lstrip('OF/'))  + '-OP' + str(mrp_production_operation.sequence) + '-MA'
        
        ope_account_id = False
        
        account_analytic_obj = self.pool.get('account.analytic.account')
        account_analytic_jour_obj = self.pool.get('account.analytic.journal')
        account_analytic_line_obj = self.pool.get('account.analytic.line')
    
        account_search = account_analytic_obj.search(cr, uid, [('code','=',ope_acc_code)])
        if not account_search:
            raise osv.except_osv(_('ERROR'), _('Analytic Account with code: %s NOT FOUND') %(ope_acc_code))
            
        for aux_var in account_search:
            ope_account_id = aux_var
        # TODO: Change this to use code instead for translational option
        # man_journal_search = account_analytic_jour_obj.search(cr, uid,[('code', '=', 'MRP')])
        
        man_journal_search = account_analytic_jour_obj.search(cr, uid,[('name', '=', 'Manufacturing')])        
        man_journal = account_analytic_jour_obj.browse(cr, uid, man_journal_search[0])
        
        values = {
                  'amount':op_cost_amount*(-1),
                  'name':in_description,
                  'date':in_date,
                  'company_id': wc.factory_id.company_id.id,
                  'account_id': ope_account_id,
                  'general_account_id': wc.factory_id.company_id.workcenter_account.id,
                  'journal_id':man_journal.id,
                  }
        new_id = account_analytic_line_obj.create(cr, uid, values)          
        account_analytic_obj.recalculate_result(cr, uid, ope_account_id)   
    
        return True

    def input_worktime(self, cr, uid, fields, context=None):
        
        if context is None:
            context = {}        
          
        if context['wtime']<=0:
            raise osv.except_osv(_('The time must be greater than 0'), _(context['wtime']))    
            
        aux = self.pool.get('mrp.production.operation')
        op = aux.browse(cr , uid, context['operation'])
        
        aux_prod = self.pool.get('mrp.production')        
        prod = aux_prod.browse(cr , uid, op.production_id.id)
        
        ops_wc_obj = self.pool.get('mrp.wc.cost')
    
        real_op_obj = self.pool.get('mrp.production.operation.real')
        real_op_search = real_op_obj.search(cr, uid,[('mrp_manu_op', '=', op.id )])        
        real_id = real_op_obj.browse(cr, uid, real_op_search[0])
        
        if real_id.state == 'draft':
            raise osv.except_osv(_('Unable to perform action'), _('Operation must be started to allocate hours')) 
        
        values = {
          'wc': context['wc'],
          'operation': context['operation'],
          'time': context['wtime'],
          'date': context['work_date'],
          'descript': context['descript'],
          'production': prod.id,
          'real_op' : real_id.id
            }
        
        res = ops_wc_obj.create(cr, uid, values)
        
        
          # inputación a contabilidad analitica
          
        ope_acc_code = 'OF'+ str(prod.name.lstrip('OF/'))+'-OP'+str(op.sequence)
        account_analytic_obj = self.pool.get('account.analytic.account')
        account_search = account_analytic_obj.search(cr, uid, [('code','=',ope_acc_code)])
        if not account_search:
            raise osv.except_osv(_('ERROR'), _('Analytic Account with code: %s NOT FOUND') %(ope_acc_code))       
        
        ope_account_id=False
        
        for aux_var in account_search:
            ope_account_id = aux_var
            
        if ope_account_id:
            resu = self.analityc_inpute(cr, uid ,context['work_date'],context['descript'],context['wc'],context['wtime'],op.id, prod.id)
        
        
        return {'type': 'ir.actions.act_window_close'}
input_time_wc()

class new_input_time_wc(osv.osv_memory):
    _inherit = "new.input.time.wc"
    _name = "new.input.time.wc"
    _description = "Input time"
    
    def input_worktime(self, cr, uid, fields, context=None):
        
        if context is None:
            context = {}        
        
        if context['wtime']<=0:
            raise osv.except_osv(_('The time must be greater than 0'), _(context['wtime']))
        aux = self.pool.get('mrp.production.operation')
        op = aux.browse(cr , uid, context['operation'])
        
        aux_prod = self.pool.get('mrp.production')        
        prod = aux_prod.browse(cr , uid, op.production_id.id)
        
        ops_wc_obj = self.pool.get('mrp.wc.cost')
        wc = op.workcenter_id
        
        real_op_obj = self.pool.get('mrp.production.operation.real')
        real_op_search = real_op_obj.search(cr, uid,[('mrp_manu_op', '=', op.id )])        
        real_id = real_op_obj.browse(cr, uid, real_op_search[0])
        
        if real_id.state == 'draft':
            raise osv.except_osv(_('Unable to perform action'), _('Operation must be started to allocate hours')) 
        
        values = {
          'wc': wc.id,
          'operation':context['operation'],
          'time': context['wtime'],
          'date':context['work_date'],
          'descript':context['descript'],
          'production':prod.id,
          'real_op' : real_id.id
            }
        
        res = ops_wc_obj.create(cr, uid, values)
        

        
        return {'type': 'ir.actions.act_window_close'}
    
new_input_time_wc()
