# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

import time
from datetime import datetime

from osv import osv, fields
import tools
from tools.translate import _


class users_ops_cost(osv.osv_memory):
    _name = "users.ops.cost"
    _description = "Operators work"

    _columns = {
          'user_id':fields.many2one('res.users','Operator'),
          'name':fields.char('Name', size = 256),
          'product_user':fields.many2one('production.opert.users','prodauxuser'),
          'workpercent':fields.float('Current %'),
          'deleteable':fields.boolean('delete'),
          'wizard_id':fields.many2one('users.costing','Wizard'),
     }
users_ops_cost()


class users_costing(osv.osv_memory):
    _name = "users.costing"
    _description = "Operation Operators"
    _columns = {
            'ops': fields.one2many('users.ops.cost','wizard_id','Operators'),
            'operation': fields.many2one('mrp.production.operation','Operation'),
    }

    def default_get(self, cr, uid, fields, context=None):
        if context is None:
            context = {}
        res = super(users_costing, self).default_get(cr, uid, fields, context=context)

        if 'aux_op_id' in context:
            act_id = context['aux_op_id']
        else:
            act_id = context['active_ids'][0]

        aux = self.pool.get('mrp.production.operation').browse(cr, uid, act_id)
        op_id = aux.id
        prod_id = aux.production_id.id

        obj = self.pool.get('mrp.production').browse(cr, uid, prod_id)

        if obj.state == 'draft':
            raise osv.except_osv(_('Unable to perform action'), _('You cannot impute hours before starting the production order.'))
        result = []

        prod_op_usr_ids = self.pool.get('production.opert.users').search(cr, uid,[('op', '=', op_id )])
        prod_op_usr = self.pool.get('production.opert.users').browse(cr, uid,prod_op_usr_ids)
        for prod in prod_op_usr:
            #codigo para sacar el prod user
            prod_us_id = prod.id
            operation_time = aux.tot_ops
            operator_time = 0
            #codigo para sacar el % y si se puede borrar
            costs_ids = self.pool.get('mrp.ops.cost').search(cr, uid,[('operation', '=', op_id ),('wuser', '=', prod_us_id )])
            costs = prod_op_usr = self.pool.get('mrp.ops.cost').browse(cr, uid,costs_ids)
            for oper in costs:
                operator_time = operator_time + oper.time
                pt = 0
                delet = False
                if operator_time == 0:
                    delet = True
                if operation_time == 0:
                    pt = 0
                else:
                    pt = ((operator_time * 100) / operation_time)

                values = {
                          'user_id': prod.user.id,
                          'name': prod.user.name,
                          'product_user': prod_us_id,
                          'workpercent': pt,
                          'deleteable': delet,
                          }
                result.append(values) 

#        else:
#            raise osv.except_osv(_('no hay produccion'), _(obj))
#        res.update({'user': result , 'production':prod_id, 'operation':op_id})
        res.update({'ops': result,  'operation':op_id})    
        return res

users_costing()


class input_time(osv.osv_memory):
    _name = "input.time"
    _description = "Input time"
    _columns = {
                'operation':fields.many2one('mrp.production.operation','Operation'),
                'wuser':fields.many2one('res.users','Operator'),
                'wtime':fields.float('time'),
                'descript':fields.text('Description'),
                'work_date':fields.date('Work date'),
                }
    _defaults = {
        'work_date': datetime.now().strftime('%Y-%m-%d'),
                }

    def input_worktime(self, cr, uid, fields, context=None):
        if context is None:
            context = {}

        if context['wtime'] <= 0:
            raise osv.except_osv(_('The time must be greater than 0'), _(context['wtime']))

        aux_prod = self.pool.get('mrp.production')
        aux_prod_op = self.pool.get('mrp.production.operation')
        op = aux_prod_op.browse(cr, uid, context['operation'])

        prod = aux_prod.browse(cr, uid, op.production_id.id)

        ops_us_obj = self.pool.get('mrp.ops.cost')

        us_obj = self.pool.get('production.opert.users')
        us_search = us_obj.search(cr, uid, [('user', '=', context['wuser']), ('op', '=', op.id)])
        if len(us_search):
            us = us_search[len(us_search) - 1]
        else:
            values = {
                'user': context['wuser'],
                'production_id': op.production_id.id,
                'op': op.id,
                   }
            res = us_obj.create(cr, uid, values)
            us_search = us_obj.search(cr, uid,[('user', '=', context['wuser'] ), ('op', '=', op.id)])
            us = us_search[0]

        real_op_obj = self.pool.get('mrp.production.operation.real')
        real_op_search = real_op_obj.search(cr, uid,[('mrp_manu_op', '=', op.id )])
        real_id = real_op_obj.browse(cr, uid, real_op_search[0])

        if real_id.state == 'draft':
            raise osv.except_osv(_('Unable to perform action'), _('Operation must be started to allocate hours')) 

        values = {
          'wuser': us,
          'user': context['wuser'],
          'operation': op.id,
          'time': context['wtime'],
          'date': context['work_date'],
          'descript': context['descript'],
          'production': prod.id,
          'real_op': real_id.id
            }
        res = ops_us_obj.create(cr, uid, values)

        return {'type': 'ir.actions.act_window_close'}
input_time()


class new_input_time(osv.osv_memory):
    _name = "new.input.time"
    _description = "new_Input time"
    _columns = {
                'operation':fields.many2one('mrp.production.operation','Operation'),
                'wuser':fields.many2one('res.users','Operator'),
                'wtime':fields.float('time'),
                'descript':fields.text('Description'),
                'work_date':fields.date('Work date'),
                'production':fields.many2one('mrp.production'),
                }
    _defaults = {
        'work_date': datetime.now().strftime('%Y-%m-%d'),
                }

    def default_get(self, cr, uid, fields, context=None):
        if context is None:
            context = {}
        res = super(new_input_time, self).default_get(cr, uid, fields, context=context)    

        obj = self.pool.get('mrp.production').browse(cr , uid, context['active_ids'][0])

        if obj.state == 'draft':
            raise osv.except_osv(_('Unable to perform action'), _('You cannot impute hours before starting the production order.')) 

        res.update({'production':context['active_ids'][0]})
        return res

    def input_real_worktime(self, cr, uid, ids, in_wuser, in_wtime, in_op, in_date, in_desc,  context=None):

        if context is None:
            context = {}

        if in_wtime <= 0:
            raise osv.except_osv(_('The time must be greater than 0'), _(in_wtime))

        aux_prod = self.pool.get('mrp.production')
        aux_prod_op = self.pool.get('mrp.production.operation')
        op = aux_prod_op.browse(cr, uid, in_op)

        prod = aux_prod.browse(cr, uid, op.production_id.id)

        ops_us_obj = self.pool.get('mrp.ops.cost')

        us_obj = self.pool.get('production.opert.users')
        us_search = us_obj.search(cr, uid, [('user', '=', in_wuser ), ('op','=',op.id)])
        if len(us_search):
            us = us_search[len(us_search)-1]
        else:
            values = {
                'user': in_wuser,
                'production_id':op.production_id.id,
                'op':op.id,
                   }
            res = us_obj.create(cr, uid, values)
            us_search = us_obj.search(cr, uid,[('user', '=', in_wuser ),('op','=',op.id)])
            us = us_search[0]

        real_op_obj = self.pool.get('mrp.production.operation.real')
        real_op_search = real_op_obj.search(cr, uid, [('mrp_manu_op', '=', op.id )])
        real_id = real_op_obj.browse(cr, uid, real_op_search[0])

        if real_id.state == 'draft':
            raise osv.except_osv(_('Unable to perform action'), _('Operation must be started to allocate hours')) 

        values = {
          'wuser': us,
          'user': in_wuser,
          'operation': op.id,
          'time': in_wtime,
          'date': in_date,
          'descript': in_desc,
          'production': prod.id,
          'real_op': real_id.id
            }

        res = ops_us_obj.create(cr, uid, values)

        return True

    def input_worktime(self, cr, uid, fields, context=None):
        if context is None:
            context = {}

        if context['wtime'] <= 0:
            raise osv.except_osv(_('The time must be greater than 0'), _(context['wtime']))

        aux_prod = self.pool.get('mrp.production')
        aux_prod_op = self.pool.get('mrp.production.operation')
        op = aux_prod_op.browse(cr , uid, context['operation'])

        prod = aux_prod.browse(cr , uid, op.production_id.id)

        ops_us_obj = self.pool.get('mrp.ops.cost')

        us_obj = self.pool.get('production.opert.users')
        us_search = us_obj.search(cr, uid, [('user', '=', context['wuser'] ), ('op','=',op.id)])
        if len(us_search):
            us = us_search[len(us_search)-1]
        else:
            values = {
                'user': context['wuser'],
                'production_id': op.production_id.id,
                'op': op.id,
                   }
            res = us_obj.create(cr, uid, values)
            us_search = us_obj.search(cr, uid, [('user', '=', context['wuser'] ), ('op','=',op.id)])
            us = us_search[0]

        real_op_obj = self.pool.get('mrp.production.operation.real')
        real_op_search = real_op_obj.search(cr, uid, [('mrp_manu_op', '=', op.id)])
        real_id = real_op_obj.browse(cr, uid, real_op_search[0])

        if real_id.state == 'draft':
            raise osv.except_osv(_('Unable to perform action'), _('Operation must be started to allocate hours')) 

        values = {
          'wuser': us,
          'user': context['wuser'],
          'operation': op.id,
          'time': context['wtime'],
          'date': context['work_date'],
          'descript': context['descript'],
          'production': prod.id,
          'real_op': real_id.id
            }

        res = ops_us_obj.create(cr, uid, values)
        return {'type': 'ir.actions.act_window_close'}
new_input_time()
