# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2010 Tiny SPRL (http://tiny.be). All Rights Reserved
#    
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _

class account_analytic_chart(osv.osv_memory):
    _name = 'account.analytic.chart'
    _inherit = 'account.analytic.chart'
    
    
    _columns = {# Proyecto
                'mrp_production_id': fields.many2one('mrp.production', 'Production'),
                }
    
    def default_get(self, cr, uid, fields, context=None):
        res={}
        if context.has_key('my_production_id'):
            res = {'mrp_production_id': context.get('my_production_id')}

        return res
    
    
    def analytic_account_chart_open_window(self, cr, uid, ids, context=None):
        mod_obj = self.pool.get('ir.model.data')
        act_obj = self.pool.get('ir.actions.act_window')
        account_obj = self.pool.get('account.analytic.account')
        result_context = {}
        if context is None:
            context = {}
        result = mod_obj.get_object_reference(cr, uid, 'account', 'action_account_analytic_account_tree2')
        id = result and result[1] or False
        result = act_obj.read(cr, uid, [id], context=context)[0]
        #data = self.read(cr, uid, ids, [])[0]
        data = self.browse(cr,uid,ids[0])       
        if data.from_date:
            result_context.update({'from_date': data.from_date})
        if data.to_date:
            result_context.update({'to_date': data.to_date})
        if data.mrp_production_id:
            account_ids = account_obj.search(cr,uid,[('mrp_production_id','=',data.mrp_production_id.id)])
            if account_ids:
                result['domain'] = [('id','=',account_ids[0])]      
        
        result['context'] = str(result_context)
        
        return result
    

account_analytic_chart()
