# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import fields,osv
from tools.translate import _


class mrp_factory(osv.osv):
    _name = 'mrp.factory'
    _description = 'Manufacturing Factory'
    _columns = {
                'name': fields.char('Factory', size=64, required=True, readonly=False),
                'active': fields.boolean('Active'),
                'description':fields.text('Description', required=False, readonly=False),
                'location_id': fields.many2one('stock.location', 'Location', size= 64, required= True, help='Specify the location of this plant'),
                'workcenter_ids': fields.one2many('mrp.workcenter', 'factory_id', 'Work Centers', required= False),
                'company_id': fields.many2one('res.company', 'Company'),
    }

    _defaults = {
        'active': lambda *a: True,
        'company_id': lambda self, cr, uid, context: self.pool.get('res.company')._company_default_get(cr, uid, 'mrp.routing', context=context)
    }
mrp_factory()