# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import osv, fields
from tools.translate import _


class mrp_operation(osv.osv):
    _name = 'mrp.operation'
    _description = 'MRP Operation'

    _columns = {
        'cod': fields.char('Code', size = 64, required=True),
        'active': fields.boolean('Active', help="If the active field is set to False, it will allow you to hide the resource record without removing it."),
        'name': fields.char('Name', size=64, required=True),
        'workcenter': fields.many2many('mrp.workcenter', 'mrp_operations_workcenter', 'operation_id', 'workcenter_id', 'Work centers'),
        'descript': fields.text('Description', help="Description of the operation"),
        'type': fields.selection([
            ('mfo', 'Manufacturing Operation'),
            ('mto', 'Maintenance Operation')], 'Operation type', size=64, required=True),
        'operation_line_ids': fields.one2many('mrp.production.workcenter.line', 'operation_id', 'Operations'),
        'operations_product': fields.one2many('mrp.bom.operations.product', 'operation_id', 'Operations'),
     }

    _defaults = {
        'type': lambda *a: 'mfo',
        'active': lambda *a: True,
    }

mrp_operation()
