# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import osv, fields
from tools.translate import _


class routing_fixed_cost(osv.osv):
    _name = 'routing.fixed.cost'
    _description = 'Routing fixed costs'
    _columns = {
                'name': fields.char('Description', size=256),
                'amount': fields.float('Amount'),
                'estimated': fields.float('Estimated amount'),
                'routing_id': fields.many2one('mrp.routing', 'Routing')
                }

routing_fixed_cost()


class mrp_routing(osv.osv):
    _description = 'Routing'
    _inherit = 'mrp.routing'

    _columns = {
        'routing_line_ids': fields.one2many('mrp.production.workcenter.line', 'routing_id', 'Operations', required = True),
        'fixed_costs': fields.one2many('routing.fixed.cost','routing_id','Fixed costs'),
    }

mrp_routing()

# The name of this class has to be changed!! This class is not related with production but routing.
class mrp_production_workcenter_line(osv.osv):
    _inherit='mrp.production.workcenter.line'
    _description = 'Work Order'

    _columns = {
        'name': fields.char('Code', size= 64),
        'descript': fields.text('Description', size = 64),
        'operation_id': fields.many2one('mrp.operation', 'Operation', required=True),
        'production_id': fields.many2one('mrp.production', 'Production Order', select=True),
        'location_id': fields.many2one('stock.location', 'Operation Location', required= True, domain=[('usage','in',('internal','supplier'))]),
        'routing_id': fields.many2one('mrp.routing', 'Parent Routing', required=True),
        'product_id': fields.many2one('product.product','Semi Product'),
        'components': fields.many2many('mrp.bom','routing_bom','routing_id','product_id','Components'),
    }
    _defaults = {
        'hour': lambda *a: 0,
        'cycle': lambda *a: 0,
    }

    def wc_onchange(self, cr, uid, ids, workcenter_id):
        value = {}
        if workcenter_id:
            wc = self.pool.get('mrp.workcenter').browse(cr, uid, workcenter_id)
            value['location_id'] = wc.location_id.id
        return {'value': value}

    def opt_onchange(self, cr, uid, ids, operation_id):
        value = {}
        if operation_id:
            opt = self.pool.get('mrp.operation').browse(cr, uid, operation_id)
            value['name'] = opt.cod
        return {'value': value}

mrp_production_workcenter_line()
