# -*- encoding: utf-8 -*-
##############################################################################
#
#    Avanzosc - Avanced Open Source Consulting
#    Copyright (C) 2011 - 2013 Avanzosc <http://www.avanzosc.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _
import decimal_precision as dp
from datetime import datetime
from dateutil.relativedelta import relativedelta

class procurement_order(osv.osv):

    _inherit = 'procurement.order'
    
    _columns = {# Línea de Pedido de Venta
                'sale_order_line_id':fields.related('move_id','sale_line_id',type='many2one',relation='sale.order.line',string='Sale Order Line', readonly=True),
                }
    
    def make_mo(self, cr, uid, ids, context=None):
        """ Make Manufacturing(production) order from procurement
        @return: New created Production Orders procurement wise 
        """
        res = {}
        company = self.pool.get('res.users').browse(cr, uid, uid, context).company_id
        production_obj = self.pool.get('mrp.production')
        move_obj = self.pool.get('stock.move')
        #wf_service = netsvc.LocalService("workflow")
        procurement_obj = self.pool.get('procurement.order')
        sale_line_obj = self.pool.get('sale.order.line')
        for procurement in procurement_obj.browse(cr, uid, ids, context=context):
            res_id = procurement.move_id.id
            newdate = datetime.strptime(procurement.date_planned, '%Y-%m-%d %H:%M:%S') - relativedelta(days=procurement.product_id.product_tmpl_id.produce_delay or 0.0)
            newdate = newdate - relativedelta(days=company.manufacturing_lead)
            if not procurement.product_id.property_stock_production.id:
                raise osv.except_osv(_('Procurement Order Error !'), _("You must define production location for product: %s") % (procurement.product_id.name,))
            produce_id = production_obj.create(cr, uid, {
                'origin': procurement.origin,
                'product_id': procurement.product_id.id,
                'product_qty': procurement.product_qty,
                'product_uom': procurement.product_uom.id,
                'product_uos_qty': procurement.product_uos and procurement.product_uos_qty or False,
                'product_uos': procurement.product_uos and procurement.product_uos.id or False,
                'location_src_id': procurement.product_id.property_stock_production.id,
                'location_dest_id': procurement.location_id.id,
                'bom_id': procurement.bom_id and procurement.bom_id.id or False,
                'date_planned': newdate.strftime('%Y-%m-%d %H:%M:%S'),
                'move_prod_id': res_id,
                'company_id': procurement.company_id.id,
            })
            res[procurement.id] = produce_id
            self.write(cr, uid, [procurement.id], {'state': 'running'})
            bom_result = production_obj.action_compute(cr, uid,
                    [produce_id], properties=[x.id for x in procurement.property_ids])
            #wf_service.trg_validate(uid, 'mrp.production', produce_id, 'button_confirm', cr)
            if res_id:
                move_obj.write(cr, uid, [res_id],
                        {'location_id': procurement.product_id.property_stock_production.id})
                
            if procurement.origin and procurement.move_id:
                if procurement.move_id.sale_line_id:
                    production_ids = production_obj.search(cr, uid,[('origin','=', procurement.origin)])
                    if ids:
                        for production in production_obj.browse(cr,uid,production_ids):
                            if procurement.procure_method == 'make_to_order':
                                production_obj.write(cr,uid,[production.id],{'sale_order_id': procurement.move_id.sale_line_id.order_id.id,
                                                                             'sale_order_line_id': procurement.move_id.sale_line_id.id})
                            else:
                                production_obj.write(cr,uid,[production.id],{'sale_order_id': procurement.move_id.sale_line_id.order_id.id})
                                
                            if production.product_id.id == procurement.move_id.sale_line_id.product_id.id and production.product_uos_qty == procurement.move_id.sale_line_id.product_uos_qty and not procurement.move_id.sale_line_id.mrp_production_id:
                                sale_line_obj.write(cr,uid,[procurement.move_id.sale_line_id.id],{'mrp_production_id': production.id})
                                    
        return res

procurement_order()