# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import fields, osv
from tools.translate import _
import time

class parcial_picking_aux_production(osv.osv_memory):
    _name = "parcial.picking.aux.production"

    _columns = {
            'stock_move_id':fields.many2one('stock.move', 'Stock move', required=True, select=True),
            'product_id':fields.many2one('product.product', 'Product', required=True, select=True),
            'product_qty': fields.float('Quantity', required=True),
            'location_id': fields.many2one('stock.location', 'Location', required=True),
            'wizard_id': fields.many2one('prod.partial.picking', 'wizard', required=True),
            }

parcial_picking_aux_production()

class production_partial_picking(osv.osv_memory):
    _name = "production.partial.picking"
    _description = "Partial Production"

    _columns = {
          'production_lines': fields.one2many('parcial.picking.aux.production', 'wizard_id', 'Moves'),

     }

    def do_full_produce(self, cr, uid, ids, context = None):

        move_obj = self.pool.get('stock.move')

        for obj in self.browse(cr, uid, ids):
            for prod in obj.production_lines:
                if context is None:
                    context = {}
                move_id = prod.stock_move_id.id
                prod_qty = prod.product_qty
                prod_loc = prod.location_id.id
                move_obj.action_consume(cr, uid, [move_id] ,prod_qty,prod_loc,context=context)
        return {'type': 'ir.actions.act_window_close'}

    def default_get(self, cr, uid, fields, context=None):

        if context is None:
            context = {}
        res = super(production_partial_picking, self).default_get(cr, uid, fields, context=context)
        objs = self.pool.get('mrp.production').browse(cr , uid, context['active_ids'])
        move_obj = self.pool.get('parcial.picking.aux.production')

        result = []
        for obj in objs:
            for prod in obj.move_created_ids:
                values = {
                          'stock_move_id': prod.id,
                          'name': prod.name,
                          'product_id': prod.product_id.id,
                          'product_qty': prod.product_qty,
                          'location_id': prod.location_id.id,
                          }
                result.append(values)

        res.update({'production_lines': result})
        return res

production_partial_picking()