# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import fields, osv
from tools.translate import _
import time


class assign_routing(osv.osv_memory):
    _name = "assign.routing"
    _description = "Manufacturing new user"

    _columns = {'routing': fields.many2one('mrp.routing', 'Routing'),
                'assign_first':fields.boolean('Assign to First Operation'),
                'assign_last':fields.boolean('Assign to Last Operation'),
                'no_assign':fields.boolean('No Assing Operation'),
                }

    def assign(self, cr, uid, ids, context=None):

        if context is None:
            context = {}

        routing_asgn_obj = self.browse(cr , uid, ids)

        routing_name = False
        routing_id = False
        for aux in routing_asgn_obj:
            routing_id = aux.routing.id
            assign_first = aux.assign_first
            assign_last = aux.assign_last
            no_assign = aux.no_assign

        if routing_id:
            routing_brow = self.pool.get('mrp.routing').browse(cr , uid, routing_id)
            routing_name = routing_brow.name
            ops_obj = self.pool.get('mrp.bom.operations.product')       
            objs = self.pool.get('mrp.bom').browse(cr , uid, context['active_ids'])
            ops = False

            for aux in objs:
                ops = aux.mrp_bom_operations_product_ids
#                for comp in aux.bom_lines:

            for to_delete in ops:
                ops_obj.unlink(cr, uid, [to_delete.id])

            wc_lines = self.pool.get('mrp.production.workcenter.line')

            wc_line_id = wc_lines.search(cr, uid, [('routing_id', '=', routing_id)])

            wc_line_obj = []

            if len(wc_line_id):
                wc_line_obj = wc_lines.browse(cr, uid, wc_line_id)

            bom_obj = self.pool.get('mrp.bom')
            w_operation_id = 0
            w_sequence = 0

            for operation in wc_line_obj:

                uom = False
                if operation.product_id.uom_id:
                    uom = operation.product_id.uom_id.id
                values = {
                          'sequence': operation.sequence,
                          'descript': operation.descript,
                          'operation_id': operation.operation_id.id,
                          'workcenter_id': operation.workcenter_id.id,
                          'bom_id': context['active_ids'][0],
                          'capacity_per_cycle': operation.workcenter_id.capacity_per_cycle,
                          'time_efficiency': operation.workcenter_id.time_efficiency,
                          'time_cycle': operation.workcenter_id.time_cycle,
                          'time_start': operation.workcenter_id.time_start,
                          'time_stop': operation.workcenter_id.time_stop,
                          'costs_hour': operation.workcenter_id.costs_hour,
                          'costs_cycle': operation.workcenter_id.costs_cycle,
                          'name':  '%s -> %s' % (operation.operation_id.name, operation.workcenter_id.name),
                          'location_id': operation.location_id.id,
                          'product_id':operation.product_id.id,
                          'semi_prod_uom':uom,
                          }
                res = ops_obj.create(cr, uid, values)  

                if assign_first == True or assign_last == True:
                    if w_sequence == 0:
                        w_operation_id = res
                        w_sequence = operation.sequence
                    else:
                        if assign_first == True:
                            if operation.sequence < w_sequence:
                                w_operation_id = res
                                w_sequence = operation.sequence
                        else:
                            if assign_last == True:
                                if operation.sequence > w_sequence:
                                    w_operation_id = res
                                    w_sequence = operation.sequence

                for boms in operation.components:
                    bom_values = {
                                  'bom_id': context['active_ids'][0],
                                  'mrp_bom_operations_product_id': res,
                                  'product_id': boms.product_id.id,
                                  'name': boms.name,
                                  'product_uom': boms.product_uom.id,
                                  'product_qty': boms.product_qty,
                                  }
                    bom_obj.create(cr, uid, bom_values)

            bom_costs_obj = self.pool.get('bom.fixed.cost')

            for del_it in objs[0].fixed_costs:
                bom_costs_obj.unlink(cr, uid, del_it.id)

            for cost in routing_brow.fixed_costs:
                values = {
                              'name': cost.name,
                              'amount': cost.amount,
                              'estimated': cost.amount,
                              'bom_id': context['active_ids'][0],
                              }
                bom_costs_obj.create(cr, uid, values)

            if assign_first == True or assign_last == True or no_assign == True:
                bom = bom_obj.browse(cr,uid,context['active_ids'][0])
                if bom.bom_lines:
                    for bom_line in bom.bom_lines:
                        if assign_first == True or assign_last == True:
                            bom_obj.write(cr,uid,[bom_line.id],{'mrp_bom_operations_product_id': w_operation_id})
                        else:
                            bom_obj.write(cr,uid,[bom_line.id],{'mrp_bom_operations_product_id': False})

        self.pool.get('mrp.bom').write(cr, uid, context['active_ids'][0] ,{'routing_id_name': routing_name,'routing_id':routing_id})     
        return {'type': 'ir.actions.act_window_close'}  

assign_routing()