# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import osv, fields

class upgrade_costs_bom_line(osv.osv_memory):
    _name = 'upgrade.costs.bom.line'
    _description = 'Upgrade Costs Bom Line'

    _columns = {'name':fields.char('Name', size=64),
                'mrp_bom_id':fields.many2one('mrp.bom', 'Mrp BOM'),
                }
    _defaults = {'name': lambda *a:'a',
                 }
    
    def default_get(self, cr, uid, fields, context=None):
        project_obj = self.pool.get('project.project')
        res = {}
        if context.has_key('my_bom_id'):
            res = {'mrp_bom_id': context.get('my_bom_id')}

        return res

    def update_costs(self, cr, uid, ids, context=None):
        mrp_bom_obj = self.pool.get('mrp.bom')
        mrp_workcenter_obj = self.pool.get('mrp.workcenter')
        mrp_bom_operations_product_obj = self.pool.get('mrp.bom.operations.product')
        if ids:
            for line in self.browse(cr,uid,ids):
                # Actualizo Maquinas
                mrp_workcenter_ids = mrp_workcenter_obj.search(cr, uid, [])
                if mrp_workcenter_ids:
                    mrp_workcenter_obj.write(cr, uid, mrp_workcenter_ids, {})     
                # Actualizo lineas de lista de materiales   
                if not line.mrp_bom_id:
                    mrp_bom_ids = mrp_bom_obj.search(cr, uid, [('bom_id','!=',False)])
                else:
                    mrp_bom_ids = mrp_bom_obj.search(cr, uid, [('bom_id','=',line.mrp_bom_id.id)])
                if mrp_bom_ids:
                    mrp_bom_obj.write(cr, uid, mrp_bom_ids, {})
                # Actualizo listas de materiales
                if not line.mrp_bom_id:
                    mrp_bom_ids = mrp_bom_obj.search(cr, uid, [('bom_id','=',False)])
                else:
                    mrp_bom_ids = mrp_bom_obj.search(cr, uid, [('id','=',line.mrp_bom_id.id),
                                                               ('bom_id','=',False)])
                    
                # Actualizo operaciones de fabricación de la lista de materiales
                if mrp_bom_ids:
                    for bom in mrp_bom_obj.browse(cr,uid,mrp_bom_ids):
                        if bom.mrp_bom_operations_product_ids:
                            for operation in bom.mrp_bom_operations_product_ids:
                                mrp_bom_operations_product_obj.write(cr, uid, [operation.id], {})
                            
                if mrp_bom_ids:
                    mrp_bom_obj.write(cr, uid, mrp_bom_ids, {})
        
        return {'type': 'ir.actions.act_window_close'}

upgrade_costs_bom_line()