# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import osv, fields
from tools.translate import _
import time
import tools
import netsvc


class wizard_check_disponibility(osv.osv_memory):    
    _name = "wizard.check.disponibility"
    _description = "Wizard Check Disponibility of Internal Picking"
       
    _columns = {'name':fields.char('name', size=64),
                }
    _defaults = {
                 'name': lambda *a:'a',
                 }
    
    def internalpicking_check_disponibility(self, cr, uid, ids, context=None):
        picking_obj = self.pool.get('stock.picking')
        move_obj = self.pool.get('stock.move')
        datas = {}
        internal_picking_ids = context.get('active_ids')
        if internal_picking_ids:
            for picking in picking_obj.browse(cr,uid,internal_picking_ids):
                if picking.type == 'internal' and picking.internal_type == 'input':
                    move_ids = [x.id for x in picking.move_lines if x.state == 'confirmed']
                    if not move_ids:
                        raise osv.except_osv(_('Warning !'),_('Not enough stock, unable to reserve the products.'))
                    move_obj.action_assign(cr, uid, move_ids)
                

        return {'type': 'ir.actions.act_window_close'}                     

wizard_check_disponibility()