# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import osv, fields
from tools.translate import _
import time
import tools
import netsvc


class wizard_process_internal_picking(osv.osv_memory):    
    _name = "wizard.process.internal.picking"
    _description = "Wizard To Process Internal Pickings"
       
    _columns = {'name':fields.char('name', size=64),
                }
    _defaults = {
                 'name': lambda *a:'a',
                 }
    
    def internalpicking_process(self, cr, uid, ids, context=None):
        picking_obj = self.pool.get('stock.picking')
        production_obj = self.pool.get('mrp.production')
        uom_obj = self.pool.get('product.uom')
        partial_datas = {
            'delivery_date' : time.strftime('%Y-%m-%d %H:%M:%S')
        }
        datas = {}
        internal_picking_ids = context.get('active_ids')
        if internal_picking_ids:
            for pick in picking_obj.browse(cr,uid,internal_picking_ids):
                if pick.type == 'internal' and pick.internal_type == 'input' and pick.state == 'assigned':
                    picking_type = production_obj.production_get_picking_type(cr, uid, pick, context={})
                    for move in pick.move_lines:      
                        calc_qty = uom_obj._compute_qty(cr, uid, move.product_uom.id, \
                                            move.product_qty, move.product_uom.id)
                        #Adding a check whether any move line contains exceeding qty to original moveline
                        product_uom = self.pool.get('decimal.precision').precision_get(cr, uid, 'Product UOM')
                        if round(calc_qty, product_uom) > round(move.product_qty, product_uom):
                            precision = '%0.' + str(dp.get_precision('Product UoM')(cr)[1] or 0) + 'f'
                            raise osv.except_osv(_('Processing Error'),
                            _('Processing quantity %s %s for %s is larger than the available quantity %s %s !')\
                            % (precision % calc_qty, move.product_uom.name, move.product_id.name,\
                               precision % move.product_qty, move.product_uom.name))
        
                        #Adding a check whether any move line contains qty less than zero
                        if calc_qty < 0:
                            precision = '%0.' + str(dp.get_precision('Product UoM')(cr)[1] or 0) + 'f'
                            raise osv.except_osv(_('Processing Error'), \
                                    _('Can not process quantity %s for Product %s !') \
                                    % (precision % move.product_qty, move.product_id.name))
        
                        partial_datas['move%s' % (move.id)] = {
                            'product_id': move.product_id.id,
                            'product_qty': calc_qty,
                            'product_uom': move.product_uom.id,
                            'prodlot_id': move.prodlot_id.id,
                        }
                        if (picking_type == 'in') and (move.product_id.cost_method == 'average'):
                            partial_datas['move%s' % (move.id)].update({
                                                            'product_price' : move.cost,
                                                            'product_currency': move.currency.id,
                                                            })
                            
                    picking_obj.do_partial(cr, uid, [pick.id], partial_datas, context={})                    

        return {'type': 'ir.actions.act_window_close'}                     

wizard_process_internal_picking()