
# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2008-2013 AvanzOSC (Daniel). All Rights Reserved
#    Date: 03/06/2013
#    
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################


from osv import fields,osv
from tools.translate import _

class mrp_bom (osv.osv): 

    _inherit = 'mrp.bom'
        
        #bom_obj = self.pool.get('mrp.bom')
        #return ( ('choice1', 'This is the choice 1'),
         #        ('choice2', 'This is the choice 2')
          #       )
       
    _columns = {
                'bom_list': fields.many2one('mrp.bom','BOM List'),
        }
    
    def onchange_mrp_bom_type(self, cr, uid, ids, prod_id=False, context =False):

        val = {}
        if ids !=[]:
            data = self.browse(cr, uid, ids[0], context=context)
            tipo = data.type
            if tipo == 'normal' and data.bom_id: # LDM Normal => Phantom and not master LDM
                bom_lst = self.search(cr,uid,[('bom_id', '=', False),('type', '=', 'phantom'),('product_id', '=', prod_id)])
                context['bom_lst'] = bom_lst
                if bom_lst != [] :
                    val ={'bom_lst' : bom_lst}
                else:
                    raise osv.except_osv(_('Error!'), _('There is no BOM for the current product.'))
                    
        return val
    
    def onchange_mrp_bom_lst (self, cr, uid, ids, bom_id=False, context=None):
        
        res = {}
        if ids:
            data = self.browse(cr, uid, ids[0], context=context)
            bom_cop_lst = self.search(cr,uid,[('bom_id','=',bom_id)])
            bom_ori_lst = self.search(cr,uid,[('bom_id','=',ids[0])])
            if bom_ori_lst !=[]:
                for bom_lst_id in bom_ori_lst:
                    self.unlink(cr,uid,bom_lst_id)
            for bom_cop_id in bom_cop_lst:
                default ={}
                orig_reg = self.browse(cr, uid, bom_cop_id, context=None)
                reg_id = self.copy(cr, uid, bom_cop_id, default, context=None)
                prod_total = orig_reg.product_qty * data.product_qty
                dict_mod = {
                            'bom_id': data.id,
                            'name': orig_reg.product_id.name,
                            'product_qty': prod_total,
                            'mrp_bom_operations_product_id': None, # Added for mrp_master_extension
                            }
                self.write(cr, uid,reg_id, dict_mod, context=None)
                #vals['bom_id'] = data.id
        return res

    def btn_recalculate(self, cr, uid, ids, context=None):
        bom_obj = self.pool.get('mrp.bom')
        for id in ids:
            phantom_bom = bom_obj.browse(cr, uid, id)
            bom_ids = bom_obj.search(cr, uid, [('bom_list','=',id)])
            for bom in bom_obj.browse(cr, uid, bom_ids):
                for line in bom.bom_lines:
                    bom_obj.unlink(cr, uid, line.id)
                bom_lines = []
                for phantom_line in phantom_bom.bom_lines:
                    values = {
                            'name': phantom_line.name,
                            'product_id': phantom_line.product_id.id,
                            'product_qty': phantom_line.product_qty,
                            'product_uom': phantom_line.product_uom.id,
                        }
                    bom_id = bom_obj.create(cr, uid, values)
                    bom_lines.append(bom_id)
                bom_obj.write(cr, uid, bom.id, {'bom_lines': [(6,0,bom_lines)],})
                            
        return True
    
mrp_bom()

class wizard_bom (osv.osv_memory):
    
    _name = 'wizard.bom'
    _description = 'Wizard bom'
    _columns = {
                'bom' : fields.many2one("mrp.bom", "BOM"),
                }
     
wizard_bom()

class wizard_bom_list (osv.osv_memory):
    
    def bom_list(self, cr, uid, bom_lst, context=None):

        mrp_bom_obj = self.pool.get('mrp.bom') 
        wizard = {
                  'type': 'ir.actions.act_window',
                  'name' : 'View Bom Lst',
                  'res_model': 'wizard.bom.list',
                  'view_type': 'tree,form',
                  'view_mode': 'form',
                  #'res_id': task_list_id,
                  'target': 'new',
                  'context' : context,
                 }
        return  wizard
    
    """ Bom List """
    _name = 'wizard.bom.list'
    _description = 'bom list'
    _columns = {
                'bom_list': fields.one2many('wizard.bom','bom_list_id','BOM List'),          
                }
    
    _defaults = {
                 #'bom_list': lambda self, cr, uid, context: context and context.get('bom_lst') or None, # Current bom list
                 # 'bom_list': bom_list, # Current user open state task list
                 }

wizard_bom_list()


class wizard_bom (osv.osv_memory):
    
    _inherit = 'wizard.bom'
    
    _columns = {
                'bom_list_id' : fields.many2one("wizard.bom.list", "BOM List"),
                }
wizard_bom() 
