# -*- encoding: utf-8 -*-
##############################################################################
#
#    Avanzosc - Avanced Open Source Consulting
#    Copyright (C) 2011 - 2013 Avanzosc <http://www.avanzosc.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _
import decimal_precision as dp

class super_operation_product_consume(osv.osv):

    _name = 'super.operation.product.consume'
    _description = 'Super Operation Product Consume'
    _rec_name = 'product_id'

    _columns = {'mrp_production_operation_real_id':fields.many2one('mrp.production.operation.real', 'Real Operation', ondelete='cascade'),
                'product_id':fields.many2one('product.product', 'Product', required=True),
                'product_qty': fields.float('Quantity', digits_compute=dp.get_precision('Product UoM')),
                'product_uom': fields.many2one('product.uom', 'Unit of Measure'),
                'consumed':fields.boolean('Consumed'),   
                }         

super_operation_product_consume()