# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import osv, fields
from tools.translate import _
import time
import tools
import netsvc


class wizard_super_operation(osv.osv_memory):    
    _name = "wizard.super.operation"
    _description = "Wizard to create one Super Operation"
       
    _columns = {'name':fields.char('name', size=64),
                }
    _defaults = {
                 'name': lambda *a:'a',
                 }
    
    def create_super_operation(self, cr, uid, ids, context=None):
        real_operation_obj = self.pool.get('mrp.production.operation.real')
        datas = {}
        real_operation_ids = context.get('active_ids')
        super_operation_id = 0
        if real_operation_ids:
            for real_operation in real_operation_obj.browse(cr,uid,real_operation_ids):
                if real_operation.state != 'ready':
                    raise osv.except_osv(_('Error'), _('The Operation: %s, is not READY') % (real_operation.name))
                else:
                    w_found = 0
                    for data in datas:        
                        datos_array = datas[data]
                        real_operation_id = datos_array['real_operation_id']
                        super_operation_id = datos_array['super_operation_id']
                        workcenter_id = datos_array['workcenter_id']
                        location_id = datos_array['location_id']
                        if real_operation_id == real_operation.operation_id.id and workcenter_id == real_operation.workcenter_id.id and location_id == real_operation.location_id.id:
                            w_found = 1
                            break
                        
                    if w_found == 0:
                        values_line = {'name': 'SOP - ' + real_operation.operation_id.name + ' - ' + str(time.strftime('%Y-%m-%d')),
                                       'operation_id': real_operation.operation_id.id,   
                                       'workcenter_id': real_operation.workcenter_id.id,
                                       'location_id': real_operation.location_id.id,
                                       'production_state': 'draft',
                                       'super_operation': True,
                                       'sequence': 1
                                       }
                        super_operation_id = real_operation_obj.create(cr, uid, values_line)      
                        real_operation_obj.write(cr, uid, [super_operation_id], {'code': 'SOP-'+str(super_operation_id)})     
                        wf_service = netsvc.LocalService("workflow")
                        wf_service.trg_validate(uid, 'mrp.production.operation.real', super_operation_id, 'send_sig', cr)     
                        realoperation = real_operation_obj.browse(cr,uid,super_operation_id)
                        if realoperation.state == 'sent':
                            wf_service.trg_validate(uid, 'mrp.production.operation.real', super_operation_id, 'receive_sig', cr) 
                            realoperation = real_operation_obj.browse(cr,uid,super_operation_id)
                            if realoperation.state == 'received':
                                wf_service.trg_validate(uid, 'mrp.production.operation.real', super_operation_id, 'button_received_to_ready', cr) 
                                
                                  
                        datas[(real_operation.operation_id.id)] = {'real_operation_id': real_operation.operation_id.id, 'super_operation_id': super_operation_id, 'workcenter_id': real_operation.workcenter_id.id, 'location_id': real_operation.location_id.id} 
                    
                    real_operation_obj.write(cr, uid, [real_operation.id], {'operation_real_id': super_operation_id})   
                    
        if super_operation_id > 0:
            real_operation_obj._create_super_operation_products(cr, uid, super_operation_id) 

        return {'type': 'ir.actions.act_window_close'}                     

wizard_super_operation()